/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.enums.EnumIsocode;
import de.ship.db.enums.EnumTransCategory;
import de.ship.db.tables.records.VCoreTranslationShortRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VCoreTranslationShort extends TableImpl<VCoreTranslationShortRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_core_translation_short</code>
     */
    public static final VCoreTranslationShort V_CORE_TRANSLATION_SHORT = new VCoreTranslationShort();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VCoreTranslationShortRecord> getRecordType() {
        return VCoreTranslationShortRecord.class;
    }

    /**
     * The column
     * <code>common_dd.v_core_translation_short.pk_core_translationkey</code>.
     */
    public final TableField<VCoreTranslationShortRecord, Integer> PK_CORE_TRANSLATIONKEY = createField(DSL.name("pk_core_translationkey"), SQLDataType.INTEGER, this, "");

    /**
     * The column
     * <code>common_dd.v_core_translation_short.pk_core_translation</code>.
     */
    public final TableField<VCoreTranslationShortRecord, Integer> PK_CORE_TRANSLATION = createField(DSL.name("pk_core_translation"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_core_translation_short.fk_trans_key</code>.
     */
    public final TableField<VCoreTranslationShortRecord, String> FK_TRANS_KEY = createField(DSL.name("fk_trans_key"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_translation_short.isocode</code>.
     */
    public final TableField<VCoreTranslationShortRecord, EnumIsocode> ISOCODE = createField(DSL.name("isocode"), SQLDataType.VARCHAR.asEnumDataType(EnumIsocode.class), this, "");

    /**
     * The column <code>common_dd.v_core_translation_short.category</code>.
     */
    public final TableField<VCoreTranslationShortRecord, EnumTransCategory> CATEGORY = createField(DSL.name("category"), SQLDataType.VARCHAR.asEnumDataType(EnumTransCategory.class), this, "");

    /**
     * The column <code>common_dd.v_core_translation_short.value</code>.
     */
    public final TableField<VCoreTranslationShortRecord, String> VALUE = createField(DSL.name("value"), SQLDataType.CLOB, this, "");

    private VCoreTranslationShort(Name alias, Table<VCoreTranslationShortRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VCoreTranslationShort(Name alias, Table<VCoreTranslationShortRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_core_translation_short" as  SELECT pk_core_translationkey,
          pk_core_translation,
          fk_trans_key,
          isocode,
          category,
          value
         FROM common_dd.v_core_translation
        WHERE (category = 'short'::common_dd.enum_trans_category);
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_core_translation_short</code> table
     * reference
     */
    public VCoreTranslationShort(String alias) {
        this(DSL.name(alias), V_CORE_TRANSLATION_SHORT);
    }

    /**
     * Create an aliased <code>common_dd.v_core_translation_short</code> table
     * reference
     */
    public VCoreTranslationShort(Name alias) {
        this(alias, V_CORE_TRANSLATION_SHORT);
    }

    /**
     * Create a <code>common_dd.v_core_translation_short</code> table reference
     */
    public VCoreTranslationShort() {
        this(DSL.name("v_core_translation_short"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VCoreTranslationShort as(String alias) {
        return new VCoreTranslationShort(DSL.name(alias), this);
    }

    @Override
    public VCoreTranslationShort as(Name alias) {
        return new VCoreTranslationShort(alias, this);
    }

    @Override
    public VCoreTranslationShort as(Table<?> alias) {
        return new VCoreTranslationShort(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreTranslationShort rename(String name) {
        return new VCoreTranslationShort(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreTranslationShort rename(Name name) {
        return new VCoreTranslationShort(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreTranslationShort rename(Table<?> name) {
        return new VCoreTranslationShort(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreTranslationShort where(Condition condition) {
        return new VCoreTranslationShort(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreTranslationShort where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreTranslationShort where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreTranslationShort where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreTranslationShort where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreTranslationShort where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreTranslationShort where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreTranslationShort where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreTranslationShort whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreTranslationShort whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
